Option Strict Off
Option Explicit On
Imports Microsoft.VisualBasic.PowerPacks.Printing.Compatibility.VB6
Imports System.Drawing.Printing
Public Class CMFform
    Inherits System.Windows.Forms.Form
    Dim Ferrite(11, 26) As Object
    Dim CoreSize As Short
    Dim AWG As Short
    Dim AP As Single
    Dim LI As Single
    Dim L As Single
    Dim I As Single
    Dim V As Single
    Dim F As Single
    Dim Z As Single
    Dim Hen As String
    Dim FreqIn As Single
    Dim FreqOut As String
    Dim PrintTopic As Short
    Dim Perm As Short
    Dim PermCount As Short
    Dim CD As Single
    Dim CDActual As Single
    Dim CDval As Short
    Dim PermLet As String
    Dim DesignMode_Renamed As String
    Dim intLoaded As Short
    Dim Conv As Single
    Dim WireDia As Single
    Dim WoundHT As Single
    Dim WoundOD As Single
    Dim WoundID As Single
    Dim intPicked As Short
    Dim intWire As Short
    Dim Multer As Short
    Dim PcuLoss As Single
    Dim WireArea As Single
    Dim DCr As Single
    Dim Trise As Single
    Dim Surface As Single
    Dim DiffArea As Single
    Dim DiffLength As Single
    Dim DiffL As Single
    Dim DiffPerm As Single
    Dim le As Single
    Dim Ae As Single
    Dim j As Short
    Dim CoreIDmin As Single
    Private IsInitializing As Boolean

    Private Sub ArrayLoad()

        'Part Number Load
        Ferrite(1, 1) = "41003"
        Ferrite(1, 2) = "41005"
        Ferrite(1, 3) = "41303"
        Ferrite(1, 4) = "41506"
        Ferrite(1, 5) = "41407"
        Ferrite(1, 6) = "41305"
        Ferrite(1, 7) = "41406"
        Ferrite(1, 8) = "41306"
        Ferrite(1, 9) = "41605"
        Ferrite(1, 10) = "42206"
        Ferrite(1, 11) = "42207"
        Ferrite(1, 12) = "42507"
        Ferrite(1, 13) = "42212"
        Ferrite(1, 14) = "42908"
        Ferrite(1, 15) = "42915"
        Ferrite(1, 16) = "43610"
        Ferrite(1, 17) = "43813"
        Ferrite(1, 18) = "43615"
        Ferrite(1, 19) = "43825"
        Ferrite(1, 20) = "44920"
        Ferrite(1, 21) = "44916"
        Ferrite(1, 22) = "44925"
        Ferrite(1, 23) = "46113"
        Ferrite(1, 24) = "44932"
        Ferrite(1, 25) = "47313"
        Ferrite(1, 26) = "48613"
        'Outside Diameter Load (inches)
        Ferrite(2, 1) = 0.375
        Ferrite(2, 2) = 0.375
        Ferrite(2, 3) = 0.5
        Ferrite(2, 4) = 0.52
        Ferrite(2, 5) = 0.5
        Ferrite(2, 6) = 0.5
        Ferrite(2, 7) = 0.5
        Ferrite(2, 8) = 0.5
        Ferrite(2, 9) = 0.625
        Ferrite(2, 10) = 0.87
        Ferrite(2, 11) = 0.87
        Ferrite(2, 12) = 1
        Ferrite(2, 13) = 0.87
        Ferrite(2, 14) = 1.142
        Ferrite(2, 15) = 1.142
        Ferrite(2, 16) = 1.417
        Ferrite(2, 17) = 1.5
        Ferrite(2, 18) = 1.417
        Ferrite(2, 19) = 1.5
        Ferrite(2, 20) = 1.932
        Ferrite(2, 21) = 1.932
        Ferrite(2, 22) = 1.932
        Ferrite(2, 23) = 2.4
        Ferrite(2, 24) = 1.932
        Ferrite(2, 25) = 2.9
        Ferrite(2, 26) = 3.375
        'Inside Diameter Load (inches)
        Ferrite(3, 1) = 0.187
        Ferrite(3, 2) = 0.187
        Ferrite(3, 3) = 0.312
        Ferrite(3, 4) = 0.29
        Ferrite(3, 5) = 0.281
        Ferrite(3, 6) = 0.312
        Ferrite(3, 7) = 0.281
        Ferrite(3, 8) = 0.312
        Ferrite(3, 9) = 0.35
        Ferrite(3, 10) = 0.54
        Ferrite(3, 11) = 0.54
        Ferrite(3, 12) = 0.61
        Ferrite(3, 13) = 0.54
        Ferrite(3, 14) = 0.748
        Ferrite(3, 15) = 0.748
        Ferrite(3, 16) = 0.906
        Ferrite(3, 17) = 0.751
        Ferrite(3, 18) = 0.906
        Ferrite(3, 19) = 0.748
        Ferrite(3, 20) = 1.252
        Ferrite(3, 21) = 1.332
        Ferrite(3, 22) = 1.252
        Ferrite(3, 23) = 1.4
        Ferrite(3, 24) = 1.332
        Ferrite(3, 25) = 1.53
        Ferrite(3, 26) = 2.187
        'Height Load (inches)
        Ferrite(4, 1) = 0.125
        Ferrite(4, 2) = 0.188
        Ferrite(4, 3) = 0.125
        Ferrite(4, 4) = 0.156
        Ferrite(4, 5) = 0.188
        Ferrite(4, 6) = 0.2
        Ferrite(4, 7) = 0.25
        Ferrite(4, 8) = 0.25
        Ferrite(4, 9) = 0.185
        Ferrite(4, 10) = 0.25
        Ferrite(4, 11) = 0.312
        Ferrite(4, 12) = 0.312
        Ferrite(4, 13) = 0.5
        Ferrite(4, 14) = 0.295
        Ferrite(4, 15) = 0.6
        Ferrite(4, 16) = 0.394
        Ferrite(4, 17) = 0.5
        Ferrite(4, 18) = 0.59
        Ferrite(4, 19) = 1.0
        Ferrite(4, 20) = 0.625
        Ferrite(4, 21) = 0.625
        Ferrite(4, 22) = 0.75
        Ferrite(4, 23) = 0.5
        Ferrite(4, 24) = 1.25
        Ferrite(4, 25) = 0.5
        Ferrite(4, 26) = 0.5
        'F perm AL Value Load
        Ferrite(5, 1) = 1314
        Ferrite(5, 2) = 1980
        Ferrite(5, 3) = 894
        Ferrite(5, 4) = 1334
        Ferrite(5, 5) = 1630
        Ferrite(5, 6) = 1430
        Ferrite(5, 7) = 2166
        Ferrite(5, 8) = 1782
        Ferrite(5, 9) = 1650
        Ferrite(5, 10) = 1812
        Ferrite(5, 11) = 2250
        Ferrite(5, 12) = 2348
        Ferrite(5, 13) = 3624
        Ferrite(5, 14) = 1902
        Ferrite(5, 15) = 3868
        Ferrite(5, 16) = 2726
        Ferrite(5, 17) = 5020
        Ferrite(5, 18) = 4040
        Ferrite(5, 19) = 10040
        Ferrite(5, 20) = 3640
        Ferrite(5, 21) = 3540
        Ferrite(5, 22) = 4460
        Ferrite(5, 23) = 4107
        Ferrite(5, 24) = 7080
        Ferrite(5, 25) = 4880
        Ferrite(5, 26) = 3310
        'J perm AL Value Load
        Ferrite(6, 1) = 2196
        Ferrite(6, 2) = 3308
        Ferrite(6, 3) = 1488
        Ferrite(6, 4) = 2295
        Ferrite(6, 5) = 2715
        Ferrite(6, 6) = 2380
        Ferrite(6, 7) = 3612
        Ferrite(6, 8) = 2968
        Ferrite(6, 9) = 2760
        Ferrite(6, 10) = 3020
        Ferrite(6, 11) = 3700
        Ferrite(6, 12) = 3913
        Ferrite(6, 13) = 6040
        Ferrite(6, 14) = 3170
        Ferrite(6, 15) = 6447
        Ferrite(6, 16) = 4543
        Ferrite(6, 17) = 8365
        Ferrite(6, 18) = 6736
        Ferrite(6, 19) = 16730
        Ferrite(6, 20) = 6065
        Ferrite(6, 21) = 5900
        Ferrite(6, 22) = 7435
        Ferrite(6, 23) = 6845
        Ferrite(6, 24) = 11800
        Ferrite(6, 25) = 8140
        Ferrite(6, 26) = 5520
        'W perm AL Value Load
        Ferrite(7, 1) = 4392
        Ferrite(7, 2) = 6616
        Ferrite(7, 3) = 2976
        Ferrite(7, 4) = 4590
        Ferrite(7, 5) = 5430
        Ferrite(7, 6) = 4760
        Ferrite(7, 7) = 7224
        Ferrite(7, 8) = 5936
        Ferrite(7, 9) = 5520
        Ferrite(7, 10) = 6040
        Ferrite(7, 11) = 7400
        Ferrite(7, 12) = 7825
        Ferrite(7, 13) = 12080
        Ferrite(7, 14) = 6340
        Ferrite(7, 15) = 12894
        Ferrite(7, 16) = 9085
        Ferrite(7, 17) = 16700
        Ferrite(7, 18) = 13400
        Ferrite(7, 19) = 33400
        Ferrite(7, 20) = 12130
        Ferrite(7, 21) = 11800
        Ferrite(7, 22) = 14870
        Ferrite(7, 23) = 13690
        Ferrite(7, 24) = 23600
        Ferrite(7, 25) = 16280
        Ferrite(7, 26) = 11040
        'Path Length Load (le)
        Ferrite(8, 1) = 2.07
        Ferrite(8, 2) = 2.07
        Ferrite(8, 3) = 3.12
        Ferrite(8, 4) = 3.06
        Ferrite(8, 5) = 2.95
        Ferrite(8, 6) = 3.12
        Ferrite(8, 7) = 2.95
        Ferrite(8, 8) = 3.12
        Ferrite(8, 9) = 3.68
        Ferrite(8, 10) = 5.42
        Ferrite(8, 11) = 5.42
        Ferrite(8, 12) = 6.17
        Ferrite(8, 13) = 5.42
        Ferrite(8, 14) = 7.32
        Ferrite(8, 15) = 7.32
        Ferrite(8, 16) = 8.97
        Ferrite(8, 17) = 8.3
        Ferrite(8, 18) = 8.97
        Ferrite(8, 19) = 8.28
        Ferrite(8, 20) = 12.3
        Ferrite(8, 21) = 12.7
        Ferrite(8, 22) = 12.3
        Ferrite(8, 23) = 14.5
        Ferrite(8, 24) = 12.7
        Ferrite(8, 25) = 16.5
        Ferrite(8, 26) = 21.5
        'Cross Section Load (Ae)
        Ferrite(9, 1) = 0.07
        Ferrite(9, 2) = 0.107
        Ferrite(9, 3) = 0.072
        Ferrite(9, 4) = 0.109
        Ferrite(9, 5) = 0.126
        Ferrite(9, 6) = 0.117
        Ferrite(9, 7) = 0.169
        Ferrite(9, 8) = 0.146
        Ferrite(9, 9) = 0.153
        Ferrite(9, 10) = 0.25
        Ferrite(9, 11) = 0.315
        Ferrite(9, 12) = 0.374
        Ferrite(9, 13) = 0.511
        Ferrite(9, 14) = 0.358
        Ferrite(9, 15) = 0.74
        Ferrite(9, 16) = 0.628
        Ferrite(9, 17) = 1.15
        Ferrite(9, 18) = 0.946
        Ferrite(9, 19) = 2.31
        Ferrite(9, 20) = 1.19
        Ferrite(9, 21) = 1.16
        Ferrite(9, 22) = 1.46
        Ferrite(9, 23) = 1.56
        Ferrite(9, 24) = 2.36
        Ferrite(9, 25) = 2.12
        Ferrite(9, 26) = 1.87
        'Window Area and Core Area Product (WaAc)
        Ferrite(10, 1) = 0.012
        Ferrite(10, 2) = 0.019
        Ferrite(10, 3) = 0.035
        Ferrite(10, 4) = 0.046
        Ferrite(10, 5) = 0.05
        Ferrite(10, 6) = 0.058
        Ferrite(10, 7) = 0.064
        Ferrite(10, 8) = 0.072
        Ferrite(10, 9) = 0.094
        Ferrite(10, 10) = 0.37
        Ferrite(10, 11) = 0.466
        Ferrite(10, 12) = 0.707
        Ferrite(10, 13) = 0.756
        Ferrite(10, 14) = 1.02
        Ferrite(10, 15) = 2.1
        Ferrite(10, 16) = 2.61
        Ferrite(10, 17) = 3.27
        Ferrite(10, 18) = 3.93
        Ferrite(10, 19) = 6.58
        Ferrite(10, 20) = 9.45
        Ferrite(10, 21) = 10.4
        Ferrite(10, 22) = 11.6
        Ferrite(10, 23) = 15.5
        Ferrite(10, 24) = 21.2
        Ferrite(10, 25) = 25.2
        Ferrite(10, 26) = 45.2
        'Wire length data area
        Ferrite(11, 1) = 0.037
        Ferrite(11, 2) = 0.052
        Ferrite(11, 3) = 0.038
        Ferrite(11, 4) = 0.049
        Ferrite(11, 5) = 0.054
        Ferrite(11, 6) = 0.054
        Ferrite(11, 7) = 0.06
        Ferrite(11, 8) = 0.059
        Ferrite(11, 9) = 0.058
        Ferrite(11, 10) = 0.071
        Ferrite(11, 11) = 0.087
        Ferrite(11, 12) = 0.094
        Ferrite(11, 13) = 0.122
        Ferrite(11, 14) = 0.087
        Ferrite(11, 15) = 0.146
        Ferrite(11, 16) = 0.119
        Ferrite(11, 17) = 0.16
        Ferrite(11, 18) = 0.155
        Ferrite(11, 19) = 0.229
        Ferrite(11, 20) = 0.218
        Ferrite(11, 21) = 0.162
        Ferrite(11, 22) = 0.198
        Ferrite(11, 23) = 0.184
        Ferrite(11, 24) = 0.276
        Ferrite(11, 25) = 0.237
        Ferrite(11, 26) = 0.219

    End Sub

    Private Sub ErrorCatch()
        Dim intError As Integer
        intError = 0

        Dim dummy As Object
        If InductanceInput.Checked = True Then
            Do While (IsNumeric(MainInput.Text) = False)
                dummy = InputBox("Inductance field requires a numeric entry." & Chr(13) & Chr(13) & "Please enter a value for Inductance.", "Invalid Entry", "1")
                MainInput.Text = dummy
            Loop
            Do While (CDbl(MainInput.Text) < 0)
                dummy = InputBox("Inductance field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for Indcutance.", "Invalid Entry", "1")
                MainInput.Text = dummy
            Loop
        ElseIf VoltageInput.Checked = True Then
            Do While (IsNumeric(MainInput.Text) = False)
                dummy = InputBox("Voltage field requires a numeric entry." & Chr(13) & Chr(13) & "Please enter a value for Voltage.", "Invalid Entry", "117")
                MainInput.Text = dummy
            Loop
            Do While (CDbl(MainInput.Text) < 0)
                dummy = InputBox("Voltage field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for Voltage.", "Invalid Entry", "117")
                MainInput.Text = dummy
            Loop
        Else
            Do While (IsNumeric(MainInput.Text) = False)
                dummy = InputBox("Impedance field requires a numeric entry." & Chr(13) & Chr(13) & "Please enter a value for Impedance.", "Invalid Entry", "50")
                MainInput.Text = dummy
            Loop
            Do While (CDbl(MainInput.Text) < 0)
                dummy = InputBox("Impedance field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for Impedance.", "Invalid Entry", "50")
                MainInput.Text = dummy
            Loop
        End If
        Do While (IsNumeric(Current.Text) = False)
            dummy = InputBox("Current field requires a numeric entry." & Chr(13) & Chr(13) & "Please enter a value for Current.", "Invalid Entry", "10")
            Current.Text = dummy
        Loop
        Do While (CDbl(Current.Text) < 0)
            dummy = InputBox("Current field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for Current.", "Invalid Entry", "10")
            Current.Text = dummy
        Loop
        If (InductanceInput.Checked = False) Then
            Do While (IsNumeric(SecondInput.Text) = False)
                dummy = InputBox("Cutoff Frequency field requires a numeric entry." & Chr(13) & Chr(13) & "Please enter a value for Cutoff Frequency.", "Invalid Entry", "100000")
                SecondInput.Text = dummy
            Loop
            Do While (CDbl(SecondInput.Text) < 0)
                dummy = InputBox("Cutoff Frequency field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for Cutoff Frequency.", "Invalid Entry", "100000")
                SecondInput.Text = dummy
            Loop
        End If
        Do While (IsNumeric(txtCD.Text) = False)
            dummy = InputBox("Current Density field requires a numeric entry." & Chr(13) & Chr(13) & "Please enter a value for Current Density.", "Invalid Entry", "400")
            txtCD.Text = dummy
        Loop
        Do While (CDbl(txtCD.Text) < 0)
            dummy = InputBox("Current Density field requires a numeric entry greater than zero." & Chr(13) & Chr(13) & "Please enter a value for Current Density.", "Invalid Entry", "400")
            txtCD.Text = dummy
        Loop
    End Sub

    Public Sub AboutMnu_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles AboutMnu.Click
        Dim intAbout As Object
        intAbout = MsgBox("Magnetics Common Mode Inductor Design Software." & Chr(13) & Chr(13) & "Version CMF-4.0, 2009, WEG", MsgBoxStyle.OkOnly, "About Common Mode Inductor Design")
    End Sub

    Private Sub CalculateButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CalculateButton.Click
        Dim HtWound As Object
        Dim WD As Object
        Dim WireLen As Object
        Dim Pi As Object
        Dim N As Object
        Dim ALcalc As Object 'All of the calculations are done here
        ' First make sure entry data is valid
        Dim intTooLarge As Short
        intTooLarge = 0
        intPicked = 0
        Call ErrorCatch()
        On Error Resume Next

        CD = CSng(txtCD.Text)
        If Fmat.Checked = True Then
            Perm = 3000
            PermCount = 1
            PermLet = "F"
        End If
        If Jmat.Checked = True Then
            Perm = 5000
            PermCount = 2
            PermLet = "J"
        End If
        If Wmat.Checked = True Then
            Perm = 10000
            PermCount = 3
            PermLet = "W"
        End If
        V = CSng(MainInput.Text)
        I = CSng(Current.Text)
        F = CSng(SecondInput.Text)
        FreqIn = F
        If InductanceInput.Checked = True Then
            L = CSng(MainInput.Text)
            LI = L * I 'Main input is inductance
            Z = 50
            F = CSng("")
        Else
            If VoltageInput.Checked = True Then
                Z = V / I
                If Z < 50 Then Z = 50
                LI = (Z * I * 1000) / (2 * 3.14 * F) 'Calculate AC inductance and current
            Else
                Z = Val(MainInput.Text)
                V = Z * I 'Impedance Calculation
                LI = (V * 1000) / (2 * 3.14 * F)
            End If
        End If
        AP = 0.386 * (((LI * 1000000) / (CD * Perm)) ^ 1.299) 'Calculate Area Product
        L = LI / I 'Calculate Inductance

        For CoreSize = 1 To 26 'Search the table to find the proper core size
            Multer = 1
            If AP > 45.2 Then 'If AP is bigger than largest core, chose biggest core
                CoreSize = 26
                Multer = 2 'And update the number of cores needed
                If AP > 90.4 Then Multer = 3
                If AP > 135.6 Then Multer = 4
                If AP > 181 Then intTooLarge = MsgBox("Filter requirements too large to calculate." & Chr(13) & "Please redesign or calculate it manually.", MsgBoxStyle.OkOnly, "Warning")
                Exit For
            ElseIf Ferrite(10, CoreSize) >= AP Then : Exit For 'Find core, load & exit
            End If
        Next CoreSize
        Select Case (intTooLarge)
            Case Is < 0
                Error (5)
            Case 1
                GoTo StopThis
        End Select
        If Multer > 1 Then
            txtPN.Left = VB6.TwipsToPixelsX(1300) 'Adjust Core Number box size for multiple cores
            txtPN.Width = VB6.TwipsToPixelsX(1955) 'and move it for proper alignment
            Select Case Multer 'Now enter part number and number required into part number text box
                Case 2
                    txtPN.Text = "(2x) " & "Z" & PermLet & "-" + Ferrite(1, CoreSize) & "-TC"
                Case 3
                    txtPN.Text = "(3x) " & "Z" & PermLet & "-" + Ferrite(1, CoreSize) & "-TC"
                Case 4
                    txtPN.Text = "(4x) " & "Z" & PermLet & "-" + Ferrite(1, CoreSize) & "-TC"
            End Select
        Else 'If it's just one core then make proper adjustments
            txtPN.Left = VB6.TwipsToPixelsX(1800)
            txtPN.Width = VB6.TwipsToPixelsX(1455)
            txtPN.Text = "Z" & PermLet & "-" + Ferrite(1, CoreSize) + "-TC" 'Display core information on screen
        End If
        If English.Checked = True Then Conv = 1 Else Conv = 25.4 'Convert table values to metric
        OD.Text = VB6.Format(Ferrite(2, CoreSize) * Conv, "#0.000") 'Load values for core dimensions
        ID.Text = VB6.Format(Ferrite(3, CoreSize) * Conv, "#0.000")
        HT.Text = VB6.Format(Ferrite(4, CoreSize) * Conv, "#0.000")
        AL.Text = Ferrite(PermCount + 4, CoreSize) 'Find proper AL Value
        ALcalc = Val(AL.Text) * Multer 'And adjust for the number of cores required
        FAP.Text = Ferrite(10, CoreSize)
        N = System.Math.Sqrt((L / ALcalc) * 1000000) 'Calculate number of turns per winding
        N = Int(N + 0.5) 'Adjust for rounding
        AWG = (-4.31 * System.Math.Log((1.889 * I) / CD)) 'Calculate wire size needed
        AWG = Int(AWG + 0.5) 'Adjust for rounding
        If AWG < 1 Then
            AWG = 1
            MsgBox("Too much current is required," & Chr(13) & "you will need to increase the" & Chr(13) & "wire size with multiple strands" & Chr(13) & "of wire or choose litz wire.", 0, "Warning")
        End If
        AreaProduct.Text = VB6.Format(AP, "##0.000") 'Display the rest of the design information
        L = (Multer * Val(AL.Text)) * (N * N) / 1000000
        F = Int((Z * 1000) / (2 * 3.14 * L) + 0.5) 'Frequency assumes 50 ohms impedance
        If L < 1 Then
            L = L * 1000 'If inductance is in micro heneries
            IndLabel.Text = "Inductance (H)" 'Adjust the number and the label
            Hen = " uH"
        Else
            IndLabel.Text = "Inductance (mH)" 'Otherwise it stays the same
            Hen = " mH"
        End If
        Inductance.Text = VB6.Format(L, "##0.00") 'Fill in the rest of the data
        Turns.Text = N
        WireSize.Text = CStr(AWG)
        WireLen = (Ferrite(11, CoreSize) * N * (1 + 0.5 * (Multer - 1)) + 0.5) * 12 'Length of wire needed in inches + 3 inch extra for tails
        DCr = WireLen * ((8.196 / 10 ^ 6) * (System.Math.Exp(0.2319 * AWG))) 'Calculate DC resistance
        If Metric.Checked = True Then WireLen = WireLen * 2.54 'Adjust for metric conversion
        WireLength.Text = Str(WireLen)
        DCres.Text = VB6.Format(DCr, "##0.0000") & " Ohm"
        FreqOut = CStr((1000 * V) / (2 * 3.14 * L * I))
        If (Hen = " uH") Then FreqOut = CStr(CDbl(FreqOut) * 1000)
        FrequencyOutput.Text = VB6.Format(FreqOut, "#######") & " Hz"
        WireDia = 0.3326 '.3326 is 0 AWG wire diameter
        For WD = 1 To AWG
            WireDia = WireDia * 0.8927 '.8927 is percent of next larger size wire
        Next WD
        WoundOD = (Ferrite(2, CoreSize) * Conv) + (2 * WireDia * Conv) + (0.03 * Conv) 'Adjust for wire diameter and Z-coating
        WoundID = (Ferrite(3, CoreSize) * Conv) - (2 * WireDia * Conv) - (0.03 * Conv) 'Note that core tolerances not yet incorperated
        WoundHT = ((Ferrite(4, CoreSize) * Conv) * Multer) + (2 * WireDia * Conv) + (0.03 * Conv)
        If (English.Checked = True) Then 'And format for screen
            txtWoundOD.Text = VB6.Format(WoundOD, "###0.000") & " in."
            txtWoundID.Text = VB6.Format(WoundID, "###0.000") & " in."
            txtWoundHt.Text = VB6.Format(WoundHT, "###0.000") & " in."
        Else
            txtWoundOD.Text = VB6.Format(WoundOD, "###0.0") & " mm"
            txtWoundID.Text = VB6.Format(WoundID, "###0.0") & " mm"
            txtWoundHt.Text = VB6.Format(WoundHT, "###0.0") & " mm"
        End If
        If (WoundOD / Conv < 0.38) Then
            txtHeader.Text = "SM-H0705-8A"
        ElseIf (WoundOD / Conv > 0.5 And WoundOD / Conv < 0.9 And WoundHT / Conv < 0.385) Then
            txtHeader.Text = "TV-H2206-4A"
        ElseIf (WoundOD / Conv < 1.1 And WoundHT / Conv < 0.51) Then
            txtHeader.Text = "TV-H2507-4A"
        ElseIf (WoundOD / Conv < 1.6 And WoundHT / Conv < 0.71) Then
            txtHeader.Text = "TV-H3813-4A"
        ElseIf (WoundOD / Conv < 2.5 And WoundHT / Conv < 0.81) Then
            txtHeader.Text = "TV-H4916-4A"
        Else
            txtHeader.Text = "None Available"
        End If
        PcuLoss = 2 * 1000 * I * I * DCr 'Calculate Copper Loss (in mW) for both windings combined
        Surface = (2 * 3.14 * (WoundOD / 2) ^ 2 + 3.14 * WoundOD * WoundHT) * 2.54 ^ 2
        Trise = (PcuLoss / Surface) ^ 0.833 'Calculate estimated Temperature Rise
        txtTrise.Text = VB6.Format(Trise, "###0.0")
        'Calculate estimated differential inductance
        'Assumed Area is 10x Core, and length is 1x Core
        DiffPerm = 2 * Perm / (1 + (Perm * 0.1))
        DiffArea = Ferrite(9, CoreSize) * Multer
        DiffLength = Ferrite(8, CoreSize)
        'Now calculate differential inductance in uH
        DiffL = (1000 * N * N * 4 * 3.14 * DiffPerm * DiffArea * (10 ^ -6)) / DiffLength
        txtDiffL.Text = VB6.Format(DiffL, "###0.00")
StopThis:
        If (intTooLarge = 1) Then
            txtPN.Text = "Too Large"
            OD.Text = ""
            ID.Text = ""
            HT.Text = ""
            DCres.Text = ""
            Inductance.Text = "N/A"
            Turns.Text = ""
            WireSize.Text = ""
            FrequencyOutput.Text = "N/A"
            txtWoundOD.Text = ""
            txtWoundID.Text = ""
            txtWoundHt.Text = ""
            txtHeader.Text = "N/A"
            AreaProduct.Text = ""
            txtTrise.Text = ""
            txtDiffL.Text = ""
            Turns.Text = ""
            WireLength.Text = ""
            AL.Text = ""
            FAP.Text = ""
        End If
    End Sub
    Private Sub PickedfromList(ByRef j As Object)
        Dim HtWound As Object
        Dim WireLen As Object
        Dim Pi As Object
        Dim WD As Object
        Dim N As Object
        Dim ALcalc As Object

        intPicked = j
        Multer = 1
        Call ErrorCatch() 'Verify that input entries are valid
        On Error Resume Next

        CD = CSng(txtCD.Text)
        If Fmat.Checked = True Then
            Perm = 3000
            PermCount = 1
            PermLet = "F"
        End If
        If Jmat.Checked = True Then
            Perm = 5000
            PermCount = 2
            PermLet = "J"
        End If
        If Wmat.Checked = True Then
            Perm = 10000
            PermCount = 3
            PermLet = "W"
        End If
        V = CSng(MainInput.Text)
        I = CSng(Current.Text)
        F = CSng(SecondInput.Text)
        FreqIn = F
        If InductanceInput.Checked = True Then
            L = CSng(MainInput.Text)
            LI = L * I 'Main input is inductance
            Z = 50
            F = CSng("")
        Else
            If VoltageInput.Checked = True Then
                Z = V / I
                If Z < 50 Then Z = 50
                LI = (Z * I * 1000) / (2 * 3.14 * F) 'Calculate AC inductance and current
            Else
                Z = Val(MainInput.Text)
                V = Z * I 'Impedance Calculation
                LI = (V * 1000) / (2 * 3.14 * F)
            End If
        End If

        L = LI / I 'Calculate Inductance
        CoreSize = j
        'Resize PN text box for stack of one core
        txtPN.Left = VB6.TwipsToPixelsX(1800)
        txtPN.Width = VB6.TwipsToPixelsX(1455)
        txtPN.Text = "Z" & PermLet & "-" + Ferrite(1, CoreSize) & "-TC" 'Display core information on screen

        If English.Checked = True Then Conv = 1 Else Conv = 25.4 'Convert table values to metric
        OD.Text = VB6.Format(Ferrite(2, CoreSize) * Conv, "#0.000") 'Load values for core dimensions
        ID.Text = VB6.Format(Ferrite(3, CoreSize) * Conv, "#0.000")
        HT.Text = VB6.Format(Ferrite(4, CoreSize) * Conv, "#0.000")
        AL.Text = Ferrite(PermCount + 4, CoreSize) 'Find proper AL Value
        ALcalc = Val(AL.Text) * Multer 'And adjust for the number of cores required
        FAP.Text = Ferrite(10, CoreSize)

        N = System.Math.Sqrt((L / ALcalc) * 1000000) 'Calculate number of turns per winding
        N = Int(N + 0.5) 'Adjust for rounding
        AWG = (-4.31 * System.Math.Log((1.889 * I) / CD)) 'Calculate wire size that will support current density requirement
        AWG = Int(AWG + 0.5) 'Adjust for rounding
        WireDia = 0.3326 '.3326 is 0 AWG wire diameter
        For WD = 1 To AWG
            WireDia = WireDia * 0.8927 '.8927 is percent of next larger size wire
        Next WD
        CoreIDmin = Ferrite(2, CoreSize) - 0.015 'Adjusts ID for core coating
        Do While (WireDia > (0.417 * 3.14 * CoreIDmin / (N + 3.14))) 'Now make sure it fits...
            intWire = 1
            AWG = AWG + 1
            WireDia = WireDia * 0.8927
        Loop
        WireArea = (3.14 * WireDia ^ 2) / 4
        If (intWire = 1) Then 'Report actual wire size
            CDActual = I / (WireArea * 2.54 ^ 2)
            intWire = MsgBox("Required wire size is too large for selected core." & Chr(13) & "Actual wire size will be AWG #" & AWG & Chr(13) & "Current Density is actually " & VB6.Format(CDActual, "######") & " A/sq cm", MsgBoxStyle.OkOnly, "Core ID Too Small")
        End If
        AreaProduct.Text = VB6.Format(AP, "##0.000") 'Display the rest of the design information
        L = (Multer * Val(AL.Text)) * (N * N) / 1000000
        F = Int((Z * 1000) / (2 * 3.14 * L) + 0.5) 'Frequency assumes 50 ohms impedance
        If L < 1 Then
            L = L * 1000 'If inductance is in micro heneries
            IndLabel.Text = "Inductance (H)" 'Adjust the number and the label
            Hen = " uH"
        Else
            IndLabel.Text = "Inductance (mH)" 'Otherwise it stays the same
            Hen = " mH"
        End If
        Inductance.Text = VB6.Format(L, "##0.00") 'Fill in the rest of the data
        Turns.Text = N
        WireSize.Text = CStr(AWG)
        WireLen = (Ferrite(11, CoreSize) * N * (1 + 0.5 * (Multer - 1)) + 0.5) * 12 'Length of wire needed in inches + 3 inch extra for tails
        DCr = WireLen * ((8.196 / 10 ^ 6) * (System.Math.Exp(0.2319 * AWG))) 'Calculate DC resistance
        If Metric.Checked = True Then WireLen = WireLen * 2.54 'Adjust for metric conversion
        WireLength.Text = Str(WireLen)
        DCres.Text = VB6.Format(DCr, "##0.0000") & " Ohm"
        FreqOut = CStr((1000 * V) / (2 * 3.14 * L * I))
        If (Hen = " uH") Then FreqOut = CStr(CDbl(FreqOut) * 1000)
        FrequencyOutput.Text = VB6.Format(FreqOut, "#######") & " Hz"

        WoundOD = (Ferrite(2, CoreSize) * Conv) + (2 * WireDia * Conv) + (0.03 * Conv) 'Adjust for wire diameter and Z-coating
        WoundID = (Ferrite(3, CoreSize) * Conv) - (2 * WireDia * Conv) - (0.03 * Conv) 'Note that core tolerances not yet incorperated
        WoundHT = ((Ferrite(4, CoreSize) * Conv) * Multer) + (2 * WireDia * Conv) + (0.03 * Conv)
        If (English.Checked = True) Then 'And format for screen
            txtWoundOD.Text = VB6.Format(WoundOD, "###0.000") & " in."
            txtWoundID.Text = VB6.Format(WoundID, "###0.000") & " in."
            txtWoundHt.Text = VB6.Format(WoundHT, "###0.000") & " in."
        Else
            txtWoundOD.Text = VB6.Format(WoundOD, "###0.0") & " mm"
            txtWoundID.Text = VB6.Format(WoundID, "###0.0") & " mm"
            txtWoundHt.Text = VB6.Format(WoundHT, "###0.0") & " mm"
        End If
        If (WoundOD / Conv < 0.38) Then
            txtHeader.Text = "SM-H0705-8A"
        ElseIf (WoundOD / Conv > 0.5 And WoundOD / Conv < 0.9 And WoundHT / Conv < 0.385) Then
            txtHeader.Text = "TV-H2206-4A"
        ElseIf (WoundOD / Conv < 1.1 And WoundHT / Conv < 0.51) Then
            txtHeader.Text = "TV-H2507-4A"
        ElseIf (WoundOD / Conv < 1.6 And WoundHT / Conv < 0.71) Then
            txtHeader.Text = "TV-H3813-4A"
        ElseIf (WoundOD / Conv < 2.5 And WoundHT / Conv < 0.81) Then
            txtHeader.Text = "TV-H4916-4A"
        Else
            txtHeader.Text = "None Available"
        End If
        PcuLoss = 1000 * I * I * DCr 'Calculate Copper Loss (in mW)
        Surface = (2 * 3.14 * (WoundOD / 2) ^ 2 + 3.14 * WoundOD * WoundHT) * 2.54 ^ 2
        Trise = (PcuLoss / Surface) ^ 0.833 'Calculate estimated Temperature Rise
        txtTrise.Text = VB6.Format(Trise, "###0.0")
        'Calculate estimated differential inductance
        'Assumed Area is 10x Core, and length is 1x Core
        DiffPerm = 2 * Perm / (1 + (Perm * 0.1))
        DiffArea = Ferrite(9, CoreSize) * Multer
        DiffLength = Ferrite(8, CoreSize)
        'Now calculate differential inductance in uH
        DiffL = (1000 * N * N * 4 * 3.14 * DiffPerm * DiffArea * (10 ^ -6)) / DiffLength
        txtDiffL.Text = VB6.Format(DiffL, "###0.00")

    End Sub

    Private Sub cmdSelCore_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSelCore.Click
        Dim Entry As String
        Dim j As Short
        lstCores.Items.Clear()
        For j = 1 To 26
            Entry = "Z" & PermLet & "-" & Ferrite(1, j) & "-TC" & " (OD = " & VB6.Format(Ferrite(2, j), "0.000") & ")"
            If (Ferrite(PermCount + 4, j) > 0) Then lstCores.Items.Add(Entry)
        Next j

        lstCores.Visible = True

    End Sub

    Public Sub DesignMnu_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs)
        Call PrintButton_Click(PrintButton, New System.EventArgs())
    End Sub

    Private Sub English_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles English.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then '(Value As Integer)
                If (intLoaded = 0) Then Call CalculateButton_Click(CalculateButton, New System.EventArgs())
                Conv = 1
            End If
        End If
    End Sub

    Private Sub ExitButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ExitButton.Click
        Me.Close()
    End Sub

    Public Sub ExitMnu_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ExitMnu.Click
        Me.Close()
    End Sub

    Private Sub Fmat_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Fmat.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Dim Material As Object '(Value As Integer)
                PermCount = 1
                Material = "F"
                If (intLoaded = 0 And lstCores.Visible = False) Then Call CalculateButton_Click(CalculateButton, New System.EventArgs())
                PermLet = "F"
                If (lstCores.Visible = True) Then Call cmdSelCore_Click(cmdSelCore, New System.EventArgs())
            End If
        End If
    End Sub

    Private Sub CMFform_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        'Center Form on Load
        Left = VB6.TwipsToPixelsX((VB6.PixelsToTwipsX(System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width) - VB6.PixelsToTwipsX(Width)) / 2)
        Top = VB6.TwipsToPixelsY((VB6.PixelsToTwipsY(System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height) - VB6.PixelsToTwipsY(Height)) / 2)
        Me.Show() 'Show form before displaying disclaimer
        Call ArrayLoad() 'Load ferrite data

        Beep()
        MsgBox("The design  generated  by  this software is  believed" & Chr(13) & "to  be  accurate.   However,   MAGNETICS  will  not  be" & Chr(13) & "held  liable  for  any  errors in  judgement  made  by" & Chr(13) & "the operator or for the design achieved.  The design" & Chr(13) & "parameters, core size calculations, wire calculations" & Chr(13) & "and all other information are a function of the circuity" & Chr(13) & "under  consideration.  Any  further  design  questions" & Chr(13) & "should be directed to:" & Chr(13) & Chr(13) & "   The MAGNETICS Application Engineering Group at" & Chr(13) & "                               (412) 696-1333" & Chr(13) & "                         magnetics@spang.com", 0, "***  MAGNETICS Disclaimer  ***")
        
        Call CalculateButton_Click(CalculateButton, New System.EventArgs())
    End Sub

    Private Sub HT_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles HT.TextChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If English.Checked = True Then
                HT.Text = VB6.Format(HT.Text, "#0.000 in.")
            Else
                HT.Text = VB6.Format(HT.Text, "##0.0 mm")
            End If
        End If
    End Sub

    Private Sub ID_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ID.TextChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If English.Checked = True Then
                ID.Text = VB6.Format(ID.Text, "#0.000 in.")
            Else
                ID.Text = VB6.Format(ID.Text, "##0.0 mm")
            End If
        End If
    End Sub

    Private Sub ImpedanceInput_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ImpedanceInput.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Dim Selector As String '(Value As Integer)
                Selector = "Impedance"
                lblMainInput.Text = "Impendance (Ohms)"
                If (intLoaded = 0) Then MainInput.Text = CStr(50)
                ToolTip1.SetToolTip(lblMainInput, "Desired impedance of inductor at the specified Cut-Off frequency")
                SecondInput.Enabled = True
                If (intLoaded = 0) Then SecondInput.Text = CStr(10000)
                PrintTopic = 2
                If (intLoaded = 0) Then Call CalculateButton_Click(CalculateButton, New System.EventArgs())
            End If
        End If
    End Sub

    Private Sub Inductance_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Inductance.TextChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            Inductance.Text = VB6.Format(Inductance.Text, "#######.##")
        End If
    End Sub

    Private Sub InductanceInput_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles InductanceInput.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Dim Selector As String '(Value As Integer)
                Selector = "Inductance"
                lblMainInput.Text = "Inductance (mH)"
                ToolTip1.SetToolTip(lblMainInput, "Desired inductance of each winding on core")
                If (intLoaded = 0) Then MainInput.Text = CStr(1)
                SecondInput.Enabled = False
                PrintTopic = 3
                If (intLoaded = 0) Then Call CalculateButton_Click(CalculateButton, New System.EventArgs())
            End If
        End If
    End Sub

    Private Sub Jmat_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Jmat.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Dim Material As Object '(Value As Integer)
                PermCount = 2
                Material = "J"
                If (intLoaded = 0 And lstCores.Visible = False) Then Call CalculateButton_Click(CalculateButton, New System.EventArgs())
                PermLet = "J"
                If (lstCores.Visible = True) Then Call cmdSelCore_Click(cmdSelCore, New System.EventArgs())
            End If
        End If
    End Sub

    Public Sub LoadMnu_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles LoadMnu.Click
        Dim intOpen As Integer
        Dim MainInputTemp As String = ""
        Dim CurrentTemp As String = ""
        Dim SecondInputTemp As String = ""
        ' CancelError is True.
        intLoaded = 1
        On Error GoTo ErrHandler
        ' Set filters.

        cmnDialog1Open.Filter = "All Files (*.*)|*.*|CMN Inductor Files (*.cmf)|*.cmf"
        cmnDialog1Save.Filter = "All Files (*.*)|*.*|CMN Inductor Files (*.cmf)|*.cmf"
        intOpen = 2
        cmnDialog1Open.FilterIndex = intOpen
        cmnDialog1Save.FilterIndex = intOpen
        ' Display the Open dialog box.
        cmnDialog1Open.ShowDialog()
        cmnDialog1Save.FileName = cmnDialog1Open.FileName
        ' Call the open file procedure.
        FileOpen(2, (cmnDialog1Open.FileName), OpenMode.Input)
        ' Write the relavent variable data to the right text boxes
        ' See comments in SaveDesignMnu for Details and meanings
        Input(2, DesignMode_Renamed)
        Select Case DesignMode_Renamed
            Case "Voltage"
                VoltageInput.Checked = True
            Case "Inductance"
                InductanceInput.Checked = True
            Case Else
                ImpedanceInput.Checked = True
        End Select
        Input(2, CD)
        txtCD.Text = CStr(CD)
        Input(2, PermLet)
        Select Case PermLet
            Case "F"
                Fmat.Checked = True
            Case "W"
                Wmat.Checked = True
            Case Else
                Jmat.Checked = True
        End Select
        Input(2, MainInputTemp)
        MainInput.Text = MainInputTemp
        Input(2, CurrentTemp)
        Current.Text = CurrentTemp
        Input(2, SecondInputTemp)
        SecondInput.Text = SecondInputTemp
        Input(2, Conv)
        If (Conv = 1) Then
            English.Checked = True
        Else
            Metric.Checked = True
        End If
        Input(2, intPicked)
        j = intPicked
        If (intPicked = 0) Then Call CalculateButton_Click(CalculateButton, New System.EventArgs())
        If (intPicked > 0) Then Call PickedfromList(j)
        ' Close file so that this file number is free for other Open/Save functions
        FileClose(2)
        intLoaded = 0
        Exit Sub

ErrHandler:
        ' User pressed Cancel button.
        intLoaded = 0
        Exit Sub
    End Sub


    Private Sub lstCores_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles lstCores.SelectedIndexChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            j = lstCores.SelectedIndex + 1
            Call PickedfromList(j)
            lstCores.Visible = False
        End If
    End Sub

    Private Sub Metric_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Metric.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Conv = 25.4
                If (intLoaded = 0) Then Call CalculateButton_Click(CalculateButton, New System.EventArgs())
            End If
        End If
    End Sub

    Public Sub mnuContact_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuContact.Click
        Dim intContact As Integer
        intContact = MsgBox("Contact MAGNETICS Applications Engineering and Sales at:" & Chr(13) & Chr(13) & "Phone: (412) 696-1333" & Chr(13) & "Fax:       (412) 696-0333" & Chr(13) & "Email:   magnetics@spang.com", MsgBoxStyle.OkOnly, "Contacting Magentics")
    End Sub

    Public Sub mnuContents_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuContents.Click
        Help.ShowHelp(Me, Application.StartupPath & "\CMF.chm")
    End Sub

    Public Sub mnuIndex_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuIndex.Click
        Help.ShowHelpIndex(Me, Application.StartupPath & "\CMF.chm")
    End Sub

    Private Sub OD_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles OD.TextChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If English.Checked = True Then
                OD.Text = VB6.Format(OD.Text, "#0.000 in.")
            Else
                OD.Text = VB6.Format(OD.Text, "##0.0 mm")
            End If
        End If
    End Sub


    Private WithEvents DocToPrint As New PrintDocument

    Private Sub DocToPrint_PrintPage(ByVal Sender As Object _
    , ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles DocToPrint.PrintPage
        Dim fontbold As New System.Drawing.Font("Arial", 10, FontStyle.Bold)
        Dim font As New System.Drawing.Font("Arial", 10)
        e.Graphics.DrawString("     Magnetics Common Mode Filter Inductor Design   " & DateString, fontbold, Brushes.Black, 120, 120)
        e.Graphics.DrawString("Input Parameters", fontbold, Brushes.Black, 120, 160)
        e.Graphics.DrawString("   Current:", font, Brushes.Black, 120, 180)
        e.Graphics.DrawString(CStr(I) & " Amps", font, Brushes.Black, 295, 180)
        If PrintTopic = 3 Then
            e.Graphics.DrawString("   Inductance:", font, Brushes.Black, 120, 200)
            e.Graphics.DrawString(MainInput.Text & " mH", font, Brushes.Black, 295, 200)
        Else
            e.Graphics.DrawString("   Cutoff Frequency:", font, Brushes.Black, 120, 200)
            e.Graphics.DrawString(CStr(FreqIn) & " Hz", font, Brushes.Black, 295, 200)
            If PrintTopic = 1 Then
                e.Graphics.DrawString("   Voltage:", font, Brushes.Black, 120, 220)
                e.Graphics.DrawString(CStr(V) & " Volts", font, Brushes.Black, 295, 220)
            Else
                e.Graphics.DrawString("   Impedance:", font, Brushes.Black, 120, 220)
                e.Graphics.DrawString(CStr(Z) & " Ohms", font, Brushes.Black, 295, 220)
            End If
        End If
        e.Graphics.DrawString("   Permeability:", font, Brushes.Black, 120, 240)
        e.Graphics.DrawString(Perm, font, Brushes.Black, 295, 240)
        e.Graphics.DrawString("   Current Density:", font, Brushes.Black, 120, 260)
        e.Graphics.DrawString(CStr(CD) & " Ohms", font, Brushes.Black, 295, 260)
        e.Graphics.DrawString("Program Output Parameters", fontbold, Brushes.Black, 120, 300)
        e.Graphics.DrawString("   Core Number:", font, Brushes.Black, 120, 320)
        e.Graphics.DrawString(txtPN.Text, font, Brushes.Black, 295, 320)
        If (txtHeader.Text <> "None Available") Then
            e.Graphics.DrawString("   Header Number:", font, Brushes.Black, 120, 340)
            e.Graphics.DrawString(txtHeader.Text, font, Brushes.Black, 295, 340)
        End If
        e.Graphics.DrawString("   Filter Inductance:", font, Brushes.Black, 120, 360)
        If IndLabel.Text = "Inductance (mH)" Then
            e.Graphics.DrawString(CStr(L) & " mH", font, Brushes.Black, 295, 360)
        Else
            e.Graphics.DrawString(CStr(L) & " uH", font, Brushes.Black, 295, 360)
        End If
        e.Graphics.DrawString("   Cutoff Frequency:", font, Brushes.Black, 120, 380)
        e.Graphics.DrawString(VB6.Format(FreqOut, "#######") & " Hz", font, Brushes.Black, 295, 380)
        e.Graphics.DrawString("   Req'd Area Product:", font, Brushes.Black, 120, 400)
        e.Graphics.DrawString(AreaProduct.Text & " cm4", font, Brushes.Black, 295, 400)
        e.Graphics.DrawString("   Turns per Side:", font, Brushes.Black, 120, 420)
        e.Graphics.DrawString(Turns.Text, font, Brushes.Black, 295, 420)
        e.Graphics.DrawString("   Wire Size (AWG):", font, Brushes.Black, 120, 440)
        e.Graphics.DrawString(WireSize.Text, font, Brushes.Black, 295, 440)
        e.Graphics.DrawString("   Wire Length:", font, Brushes.Black, 120, 460)
        e.Graphics.DrawString(WireLength.Text, font, Brushes.Black, 295, 460)
        e.Graphics.DrawString("   DC Resistance:", font, Brushes.Black, 120, 480)
        e.Graphics.DrawString(DCres.Text, font, Brushes.Black, 295, 480)
        e.Graphics.DrawString("   Temperature Rise:", font, Brushes.Black, 120, 500)
        e.Graphics.DrawString(txtTrise.Text & "degrees C", font, Brushes.Black, 295, 500)
        e.Graphics.DrawString("   Est. Differential Ind.:", font, Brushes.Black, 120, 520)
        e.Graphics.DrawString(txtDiffL.Text & "uH", font, Brushes.Black, 295, 520)
        e.Graphics.DrawString("   Wound OD:", font, Brushes.Black, 120, 540)
        e.Graphics.DrawString(txtWoundOD.Text, font, Brushes.Black, 295, 540)
        e.Graphics.DrawString("   Wound ID:", font, Brushes.Black, 120, 560)
        e.Graphics.DrawString(txtWoundID.Text, font, Brushes.Black, 295, 560)
        e.Graphics.DrawString("   Wound Ht:", font, Brushes.Black, 120, 580)
        e.Graphics.DrawString(txtWoundHt.Text, font, Brushes.Black, 295, 580)
        e.Graphics.DrawString("Selected Core Parameters", fontbold, Brushes.Black, 120, 620)
        e.Graphics.DrawString("   Outside Diameter:", font, Brushes.Black, 120, 640)
        e.Graphics.DrawString(OD.Text, font, Brushes.Black, 295, 640)
        e.Graphics.DrawString("   Inside Diameter:", font, Brushes.Black, 120, 660)
        e.Graphics.DrawString(ID.Text, font, Brushes.Black, 295, 660)
        e.Graphics.DrawString("   Core Height:", font, Brushes.Black, 120, 680)
        e.Graphics.DrawString(HT.Text, font, Brushes.Black, 295, 680)
        e.Graphics.DrawString("   AL Value of Core:", font, Brushes.Black, 120, 700)
        e.Graphics.DrawString(AL.Text & " mh/1000 turns", font, Brushes.Black, 295, 700)
        e.Graphics.DrawString("   Core Area Product:", font, Brushes.Black, 120, 720)
        e.Graphics.DrawString(FAP.Text & " cm4", font, Brushes.Black, 295, 720)
    End Sub
    Public Sub PrintButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintButton.Click
        Dim PrintDialog1 As New PrintDialog
        If PrintDialog1.ShowDialog = 1 Then
            DocToPrint.PrinterSettings = PrintDialog1.PrinterSettings
            DocToPrint.Print()
        End If
    End Sub

    Public Sub SaveDesignMnu_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles SaveDesignMnu.Click

        ' CancelError is True.
        On Error GoTo ErrHandler
        ' Set filters.

        cmnDialog1Open.Filter = "All Files (*.*)|*.*|CMN Inductor Files (*.cmf)|*.cmf"
        cmnDialog1Save.Filter = "All Files (*.*)|*.*|CMN Inductor Files (*.cmf)|*.cmf"
        ' Specify default filter.
        cmnDialog1Open.DefaultExt = ".cmf"
        cmnDialog1Save.DefaultExt = ".cmf"
        cmnDialog1Open.FilterIndex = 2
        cmnDialog1Save.FilterIndex = 2
        ' Display the Save As dialog box.
        cmnDialog1Save.ShowDialog()
        cmnDialog1Open.FileName = cmnDialog1Save.FileName
        ' Call the save file procedure.
        FileOpen(2, (cmnDialog1Open.FileName), OpenMode.Output)
        ' Write the relavent variable data to the right text boxes
        If (InductanceInput.Checked = True) Then
            DesignMode_Renamed = "Inductance"
        Else
            If (VoltageInput.Checked) = True Then
                DesignMode_Renamed = "Voltage"
            Else
                DesignMode_Renamed = "Impedance"
            End If
        End If
        WriteLine(2, DesignMode_Renamed)
        WriteLine(2, CD)
        WriteLine(2, PermLet)
        WriteLine(2, MainInput.Text)
        WriteLine(2, Current.Text)
        WriteLine(2, SecondInput.Text)
        WriteLine(2, Conv)
        WriteLine(2, intPicked)
        FileClose(2)
        Exit Sub

ErrHandler:
        ' User pressed Cancel button.
        Exit Sub
    End Sub

    Private Sub Turns_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Turns.TextChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            Turns.Text = VB6.Format(Turns.Text, "#######")
        End If
    End Sub

    Private Sub VoltageInput_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles VoltageInput.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Dim FileSelector As String
                Dim Selector As String '(Value As Integer)
                Selector = "Voltage"
                FileSelector = "Voltage"
                lblMainInput.Text = "Voltage (Vrms)"
                ToolTip1.SetToolTip(lblMainInput, "Line Input Voltage")
                If (intLoaded = 0) Then MainInput.Text = CStr(117)
                SecondInput.Enabled = True
                If (intLoaded = 0) Then SecondInput.Text = CStr(10000)
                PrintTopic = 1
                If (intLoaded = 0) Then Call CalculateButton_Click(CalculateButton, New System.EventArgs())
            End If
        End If
    End Sub

    Private Sub WireLength_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles WireLength.TextChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If English.Checked = True Then
                WireLength.Text = VB6.Format(WireLength.Text, "#####.# in.")
            Else
                WireLength.Text = VB6.Format(WireLength.Text, "#####.# cm")
            End If
        End If
    End Sub

    Private Sub WireSize_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles WireSize.TextChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            WireSize.Text = VB6.Format(WireSize.Text, "###")
        End If
    End Sub

    Private Sub Wmat_CheckedChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Wmat.CheckedChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            If eventSender.Checked Then
                Dim Material As Object '(Value As Integer)
                PermCount = 3
                Material = "W"
                If (intLoaded = 0 And lstCores.Visible = False) Then Call CalculateButton_Click(CalculateButton, New System.EventArgs())
                PermLet = "W"
                If (lstCores.Visible = True) Then Call cmdSelCore_Click(cmdSelCore, New System.EventArgs())
            End If
        End If
    End Sub

    Private Sub PrintMnu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintMnu.Click
        Dim PrintDialog1 As New PrintDialog
        If PrintDialog1.ShowDialog = 1 Then
            DocToPrint.PrinterSettings = PrintDialog1.PrinterSettings
            DocToPrint.Print()
        End If
    End Sub

End Class